// CODE C (Arduino) de description du TCO : Saint-Sernin_v4
// Généré par DELPHI/TCO_Web2 (Utpeca) le 30/03/2023 15:11:40
/*********************************************************************/

// Définition du nom du TCO
/*********************************************************************/
String nomTCO = "Saint-Sernin";

/*********************************************************************/
// Définition de la table des Appareils
/*********************************************************************/
typedef struct
{
  char   etaApp;    // état de l'appareil ( de '1' à '4')
  char   typApp;    // type de l'appareil ('A', 'X', 'T', 'Y')
  byte   noMot1;    // No du 1er moteur (de 1 à 8)
  byte   noMot2;    // No du 2me moteur (de 1 à 8)
  byte   noRcpt;    // No du ESP32/ESP8266 récepteur
} appareil;

#define NBMOT 8
appareil t_App[NBMOT] =
{
  {'1', 'A', 1, 0, 1},
  {'1', 'A', 2, 0, 1},
  {'1', 'A', 3, 0, 1},
  {'2', 'A', 4, 0, 1},
  {'1', 'A', 5, 0, 1},
  {'2', 'A', 6, 0, 1},
  {'1', ' ', 0, 0, 0},
  {'1', ' ', 0, 0, 0}
};

/*********************************************************************/
// Définition de la table des Sections de voie
/*********************************************************************/
typedef struct
{
  String nomSek;    // nom de la section
  char   etaSek;    // état de la section ( '1' alimenté, '0' sinon)
  byte   no_Rel;    // No du relais (de 1 à 8)
  byte   noRcpt;    // No du ESP32/ESP8266 récepteur
} section;

#define NBSEK 8
section t_Sek[NBSEK] =
{
  {"C001", '0', 1, 4},
  {"C002", '0', 2, 4},
  {"C003", '0', 3, 4},
  {"C004", '0', 4, 4},
  {"C005", '0', 5, 4},
  {"C006", '0', 6, 4},
  {"C007", '0', 7, 4},
  {"    ", '0', 0, 0}
};

// Remplacer %CONSTRUIRE_TCO% par la table HTML des vignettes
/*********************************************************************/
String processor(const String& var)
{
  if (var == "CONSTRUIRE_TCO")
  {
    String tco = "";
    tco += "<table border='0' cellspacing='0' cellpadding='0'><tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='Sign' id='X00Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X04Y00'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirG1' id='X05Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X09Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X10Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X11Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirD1' id='X12Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y00'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirG1' id='X15Y00'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X16Y00', 'Sig1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Sig1', 'X16Y00')\" onmouseout=\"EffaceEtiq('X16Y00')\">\n"; 
    tco += "     <img class='ang180' src='Sig1' id='X16Y00'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='BgHd1' id='X04Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X05Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X06Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X07Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X08Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X09Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X10Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X11Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y01'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirD1' id='X13Y01'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp1=ChangeAig(posApp1, 'Aig1', 'AigD2')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig1', 'X14Y01')\" onmouseout=\"EffaceEtiq('X14Y01')\">\n"; 
    tco += "     <img class='ang180' src='AigD2_E1' name='imgAig1' id='X14Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X15Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X16Y01'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y02'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp2=ChangeAig(posApp2, 'Aig2', 'AigD2')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig2', 'X03Y02')\" onmouseout=\"EffaceEtiq('X03Y02')\">\n"; 
    tco += "     <img class='ang000' src='AigD2_E1' name='imgAig2' id='X03Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X04Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X05Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X09Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X10Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X11Y02'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp3=ChangeAig(posApp3, 'Aig3', 'AigG1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig3', 'X12Y02')\" onmouseout=\"EffaceEtiq('X12Y02')\">\n"; 
    tco += "     <img class='ang180' src='AigG1_E1' name='imgAig3' id='X12Y02'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp4=ChangeAig(posApp4, 'Aig4', 'AigG1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig4', 'X13Y02')\" onmouseout=\"EffaceEtiq('X13Y02')\">\n"; 
    tco += "     <img class='ang000' src='AigG1_E2' name='imgAig4' id='X13Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X14Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirD1' id='X15Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X16Y02'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X00Y03', 'Sig1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Sig2', 'X00Y03')\" onmouseout=\"EffaceEtiq('X00Y03')\">\n"; 
    tco += "     <img class='ang000' src='Sig1' id='X00Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X01Y03'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp5=ChangeAig(posApp5, 'Aig5', 'AigG1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig5', 'X02Y03')\" onmouseout=\"EffaceEtiq('X02Y03')\">\n"; 
    tco += "     <img class='ang000' src='AigG1_E1' name='imgAig5' id='X02Y03'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp6=ChangeAig(posApp6, 'Aig6', 'AigD1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig6', 'X03Y03')\" onmouseout=\"EffaceEtiq('X03Y03')\">\n"; 
    tco += "     <img class='ang000' src='AigD1_E2' name='imgAig6' id='X03Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X04Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X05Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X09Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X10Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirG1' id='X11Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X15Y03'></td>\n"; 
    tco += "<td> <img class='ang090' src='VirG1' id='X16Y03'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y04'></td>\n"; 
    tco += "<td> <img class='ang090' src='BgHd1' id='X04Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X05Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X06Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X07Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X08Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X09Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X10Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X11Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X15Y04'></td>\n"; 
    tco += "<td> <img class='ang090' src='H1' id='X16Y04'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X04Y05'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirD1' id='X05Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y05'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X09Y05', 'But5')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('But3', 'X09Y05')\" onmouseout=\"EffaceEtiq('X09Y05')\">\n"; 
    tco += "     <img class='ang180' src='But5' id='X09Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X10Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X11Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X15Y05'></td>\n"; 
    tco += "<td> <img class='ang090' src='H1' id='X16Y05'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X04Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X05Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X06Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X07Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X08Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X09Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X10Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X11Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y06'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X15Y06'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X16Y06', 'Sig1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Sig4', 'X16Y06')\" onmouseout=\"EffaceEtiq('X16Y06')\">\n"; 
    tco += "     <img class='ang090' src='Sig1' id='X16Y06'></td>\n"; 
    tco += "</tr>\n";
    tco += "</table>\n";
    return tco;
  }
  else if (var == "NOM_DU_TCO")  { return nomTCO; }
  else return String();
}

/*********************************************************************/
void ChargerVignettes()
/*********************************************************************/
// Route pour charger TCOWeb4.css file, TCOWeb4.js file et les vignettes
{
  server.on("/TCOWeb4.css", HTTP_GET, [](AsyncWebServerRequest * request)
    { request->send(SPIFFS, "/TCOWeb4.css", "text/css"); });
  server.on("/TCOWeb4.js", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/TCOWeb4.js", "text/javascript"); });
  server.on("/Saint-Sernin", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Saint-Sernin.js", "text/javascript"); });

  server.on("/Pierre", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Pierre.gif", "image/gif"); });
  server.on("/Ligne", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Ligne.gif", "image/gif"); });
  server.on("/Titre1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Titre1.gif", "image/gif"); });
  server.on("/Locoduino", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Locoduino.gif", "image/gif"); });
  server.on("/Icon1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Icon1.png", "image/png"); });
  server.on("/Pierre60x40", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Pierre60x40.png", "image/png"); });
  server.on("/Sign", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Sign.png", "image/png"); });
  server.on("/vide", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/vide.png", "image/png"); });
  server.on("/VirG1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirG1.png", "image/png"); });
  server.on("/VirG1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirG1_I5.png", "image/png"); });
  server.on("/VirG1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirG1_I6.png", "image/png"); });
  server.on("/H1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/H1.png", "image/png"); });
  server.on("/H1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/H1_I5.png", "image/png"); });
  server.on("/H1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/H1_I6.png", "image/png"); });
  server.on("/VirD1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirD1.png", "image/png"); });
  server.on("/VirD1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirD1_I5.png", "image/png"); });
  server.on("/VirD1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirD1_I6.png", "image/png"); });
  server.on("/Sig1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Sig1.png", "image/png"); });
  server.on("/Sig1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Sig1_I5.png", "image/png"); });
  server.on("/Sig1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Sig1_I6.png", "image/png"); });
  server.on("/BgHd1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/BgHd1.png", "image/png"); });
  server.on("/BgHd1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/BgHd1_I5.png", "image/png"); });
  server.on("/BgHd1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/BgHd1_I6.png", "image/png"); });
  server.on("/AigD2_E1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigD2_E1.png", "image/png"); });
  server.on("/AigD2_E2", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigD2_E2.png", "image/png"); });
  server.on("/AigG1_E1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigG1_E1.png", "image/png"); });
  server.on("/AigG1_E2", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigG1_E2.png", "image/png"); });
  server.on("/AigD1_E1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigD1_E1.png", "image/png"); });
  server.on("/AigD1_E2", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigD1_E2.png", "image/png"); });
  server.on("/But5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/But5.png", "image/png"); });
  server.on("/But5_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/But5_I5.png", "image/png"); });
  server.on("/But5_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/But5_I6.png", "image/png"); });
}
